/*
	Zupanijsko natjecanje - II. podskupina - 3. zadatak (POSTER)
	Rjesenje napisao: Zvonimir Bujanovic
*/

#include <cstdio>
#include <cstdlib>

#define MIN_POSTERA 	 0
#define MAX_POSTERA 	 5
#define MIN_X       	 0
#define MAX_X       	10
#define MIN_Y       	 0
#define MAX_Y       	10
#define MIN_STRANICA	 1
#define MAX_STRANICA 	10

#define error( s ) { printf( "%s\n", s ); exit( 0 ); }

int main( void )
{
	int brojPostera, zid[ MAX_X ][ MAX_Y ] = { 0 };
	scanf( "%d", &brojPostera );
	
	if( !( MIN_POSTERA <= brojPostera && brojPostera <= MAX_POSTERA ) )
		error( "Broj postera je pogresan." );
		
	for( int poster = 0; poster < brojPostera; ++poster )
	{
		int x, y, stranica;
		scanf( "%d%d%d", &x, &y, &stranica );
		
		if( !( MIN_X <= x && x <= MAX_X ) )
			error( "X koordinata je pogresna." );
			
		if( !( MIN_Y <= y && y <= MAX_Y ) )
			error( "Y koordinata je pogresna." );
			
		if( !( MIN_STRANICA <= stranica && stranica <= MAX_STRANICA ) )
			error( "Duljina stranice koordinata je pogresna." );
			
		if( !( x + stranica <= MAX_X && y + stranica <= MAX_Y ) )
			error( "Poster ne stane na zid." );
			
		for( int xx = x; xx < x + stranica; ++xx )
			for( int yy = y; yy < y + stranica; ++yy )
				zid[ xx ][ yy ] = 1;
	}

	int povrsina = 0, maxStranica = 0;
	for( int x = 0; x < MAX_X; ++x )
		for( int y = 0; y < MAX_Y; ++y )
			if( zid[ x ][ y ] == 1 )
				++povrsina;
			else
			{			
				int ok = 1, stranica = 1;
				while( ok )
				{
					++stranica;
					if( !( x + stranica <= MAX_X && y + stranica <= MAX_Y ) )
					{
						ok = 0;
						break;
					}
					
					for( int xx = x; xx < x + stranica; ++xx )
						for( int yy = y; yy < y + stranica; ++yy )
							if( zid[ xx ][ yy ] == 1 )
								ok = 0;				
				}
				
				--stranica;
				if( maxStranica < stranica )
					maxStranica = stranica;
			}

	printf( "POVRSINA: %d\n", povrsina );
	printf( "NAJVECI: %d\n", maxStranica );

	return 0;
}
