/*
	Drzavno natjecanje 2009. - II. podskupina
	3. zadatak - ZIDINE

	Rjesenje napisao: Zvonimir Bujanovic
*/

#include <cstdio>
#include <cstdlib>
#include <queue>

using namespace std;

int nR, nS, R, S;
char polje[ 30 ][ 30 ];
int brojKljuceva = 0, red[ 10 ], stup[ 10 ];
int udalj[ 30 ][ 30 ];
int trebaSkupiti;
int minSekundi = 1000000;

struct pos
{
	int red, stup;
	pos( int _red, int _stup ) { red = _red, stup = _stup;  }
};

int bfs( int start, int cilj )
{
	int bio[ 30 ][ 30 ] = { 0 };

	bio[ red[ start ] ][ stup[ start ] ] = 1;
	pos P( red[ start ], stup[ start ] );

	queue<pos> Q;
	
	Q.push( P );
	while( !Q.empty() )
	{
		pos pp = Q.front(); Q.pop();

		int r = pp.red, s = pp.stup;
		
		for( int dr = -1; dr <= 1; ++dr )
		    for( int ds = -1; ds <= 1; ++ds )
		        if( dr * ds == 0 && dr + ds != 0 && polje[ r + dr ][ s + ds ] != '#' && !bio[ r + dr ][ s + ds ] )
		        {
					bio[ r + dr ][ s + ds ] = bio[ r ][ s ] + 1;
					Q.push( pos( r + dr, s + ds ) );
				}
	}
	
	return bio[ red[ cilj ] ][ stup[ cilj ] ] - 1;
}

int bio[ 10 ];
void obidji( int zadnjaPozicija, int skupioDosad, int potrosioSekundi  )
{
	if( skupioDosad == trebaSkupiti )
	{
		if( minSekundi > potrosioSekundi )
		    minSekundi = potrosioSekundi;

		return;
	}

	if( potrosioSekundi >= minSekundi )
	    return;

	for( int kljuc = 0; kljuc < brojKljuceva; ++kljuc )
	    if( !bio[ kljuc ] )
	    {
			bio[ kljuc ] = 1;
			obidji( kljuc, skupioDosad + 1, potrosioSekundi + udalj[ zadnjaPozicija ][ kljuc ] );
			bio[ kljuc ] = 0;
		}
}

int main( void )
{
	scanf( "%d%d%d", &nR, &nS, &trebaSkupiti );
	for( int r = 0; r < nR; ++r )
	    scanf( " %s", polje[ r ] );
	    
	// nadji lokacije dukata i spremi ih u listu
	for( int r = 0; r < nR; ++r )
	    for( int s = 0; s < nS; ++s )
	        if( polje[ r ][ s ] == 'K' )
	        {
				red[ brojKljuceva ] = r;
				stup[ brojKljuceva ] = s;
				
				++brojKljuceva;
			}
			else if( polje[ r ][ s ] == 'X' )
			    R = r, S = s;

	// nadji sve udaljenosti izmedju kljuceva
	red[ brojKljuceva ] = R; stup[ brojKljuceva ] = S;
	for( int i = 0; i <= brojKljuceva; ++i )
	    for( int j = 0; j <= brojKljuceva; ++j )
	        udalj[ i ][ j ] = bfs( i, j );
	
	// nadji Tomislavovu poziciju i obidji kljuceve na sve moguce nacine
	obidji( brojKljuceva, 0, 0 );
	printf( "%d\n", minSekundi );
	
	return 0;
}
